
####### Expanded from @PACKAGE_INIT@ by configure_package_config_file() #######
####### Any changes to this file will be overwritten by the next CMake run ####
####### The input file was Config.cmake.in                            ########

get_filename_component(PACKAGE_PREFIX_DIR "${CMAKE_CURRENT_LIST_DIR}/../../../" ABSOLUTE)

macro(set_and_check _var _file)
  set(${_var} "${_file}")
  if(NOT EXISTS "${_file}")
    message(FATAL_ERROR "File or directory ${_file} referenced by variable ${_var} does not exist !")
  endif()
endmacro()

macro(check_required_components _NAME)
  foreach(comp ${${_NAME}_FIND_COMPONENTS})
    if(NOT ${_NAME}_${comp}_FOUND)
      if(${_NAME}_FIND_REQUIRED_${comp})
        set(${_NAME}_FOUND FALSE)
      endif()
    endif()
  endforeach()
endmacro()

####################################################################################

# provide meta-data
set(passwordfile_varname "PASSWORD_FILE")
set(passwordfile_static_varname "PASSWORD_FILE")
set(PASSWORD_FILE_DISPLAY_NAME "Passwordfile library")
set(PASSWORD_FILE_AUTHOR "Martchus")
set(PASSWORD_FILE_VERSION "3.1.4")
set(PASSWORD_FILE_VERSION_MAJOR "3")
set(PASSWORD_FILE_VERSION_MINOR "1")
set(PASSWORD_FILE_VERSION_PATCH "4")
set(PASSWORD_FILE_GIT_REV_COUNT "")
set(PASSWORD_FILE_GIT_LAST_COMMIT_ID "")
set(PASSWORD_FILE_URL "https://github.com/Martchus/passwordfile")
set(PASSWORD_FILE_DESCRIPTION "C++ library to read/write passwords from/to encrypted files")

# define general config
set(PASSWORD_FILE_IS_HEADER_ONLY NO)
set(PASSWORD_FILE_HAS_SHARED_LIB ON)
set(PASSWORD_FILE_HAS_STATIC_LIB ON)
set(PASSWORD_FILE_INCLUDE_DIRS "${PACKAGE_PREFIX_DIR}/include")
set(PASSWORD_FILE_BIN_DIR "${PACKAGE_PREFIX_DIR}/bin")
set(PASSWORD_FILE_LIB_DIR "${PACKAGE_PREFIX_DIR}/lib")
set(PASSWORD_FILE_MODULE_DIRS "${PACKAGE_PREFIX_DIR}/share/passwordfile/cmake/modules")
set(PASSWORD_FILE_CONFIG_DIRS "${PACKAGE_PREFIX_DIR}/share/passwordfile/cmake")
set(PASSWORD_FILE_PRIVATE_QT_MODULES "")
set(PASSWORD_FILE_PRIVATE_KF_MODULES "")
set(PASSWORD_FILE_PUBLIC_QT_MODULES "")
set(PASSWORD_FILE_PUBLIC_KF_MODULES "")
set(PASSWORD_FILE_HAS_QT_TRANSLATION_FILES )
set(PASSWORD_FILE_QT_RESOURCES )

# define shared library config
if(PASSWORD_FILE_HAS_SHARED_LIB)
    set(PASSWORD_FILE_SHARED_LIB "passwordfile")
    set(PASSWORD_FILE_SHARED_LIB_DEPENDS c++utilities)
    set(PASSWORD_FILE_SHARED_LIB_COMPILE_DEFINITIONS )
    set(PC_PKG_SHARED_passwordfile "passwordfile")
    if(NOT TARGET "${PASSWORD_FILE_SHARED_LIB}")
        include("${CMAKE_CURRENT_LIST_DIR}/passwordfileSharedTargets.cmake")
    endif()
endif()

# define static library config
if(PASSWORD_FILE_HAS_STATIC_LIB)
    set(PASSWORD_FILE_STATIC_LIB "passwordfile_static")
    set(PASSWORD_FILE_STATIC_LIB_DEPENDS c++utilities_static /usr/i686-w64-mingw32/lib/libz.a;/usr/i686-w64-mingw32/lib/libcrypto.a)
    set(PASSWORD_FILE_STATIC_LIB_COMPILE_DEFINITIONS PASSWORD_FILE_STATIC)
    set(PC_PKG_STATIC_passwordfile_static "passwordfile_static")
    if(NOT TARGET "${PASSWORD_FILE_STATIC_LIB}")
        include("${CMAKE_CURRENT_LIST_DIR}/passwordfileStaticTargets.cmake")
    endif()
endif()

# set default target: prefer shared lib over static lib
if(PASSWORD_FILE_HAS_SHARED_LIB)
    set(PASSWORD_FILE_LIB "passwordfile")
else()
    set(PASSWORD_FILE_LIB "passwordfile_static")
endif()

# define macro to ease use of library
macro(use_PASSWORD_FILE)
    # make CMake modules of the project available
    list(APPEND CMAKE_MODULE_PATH ${PASSWORD_FILE_MODULE_DIRS})
    # add include directories
    include_directories(BEFORE SYSTEM ${PASSWORD_FILE_INCLUDE_DIRS})
    # link against library (also "link" against header-only libs to get compile defs and interface link libs)
    link_directories(${PASSWORD_FILE_LIB_DIR})
    include(3rdParty)
    if(NOT ARGV0)
        set(PASSWORD_FILE_LINKAGE AUTO_LINKAGE)
    else()
        set(PASSWORD_FILE_LINKAGE "${ARG0}")
    endif()
    link_against_library(PASSWORD_FILE "${PASSWORD_FILE_LINKAGE}" REQUIRED)
    # add required Qt and KF modules
    list(APPEND IMPORTED_QT_MODULES ${PASSWORD_FILE_PUBLIC_QT_MODULES})
    list(APPEND IMPORTED_KF_MODULES ${PASSWORD_FILE_PUBLIC_KF_MODULES})
    # add required translations to APP_SPECIFIC_QT_TRANSLATION_FILES_ARRAY
    if(PASSWORD_FILE_HAS_QT_TRANSLATION_FILES)
        list(APPEND APP_SPECIFIC_QT_TRANSLATION_FILES passwordfile)
    endif()
    # ensure Qt resources of static libs are loaded
    if(USE_STATIC_PASSWORD_FILE AND PASSWORD_FILE_QT_RESOURCES)
        message(STATUS "Adding ${PASSWORD_FILE_QT_RESOURCES} to LIBRARIES_QT_RESOURCES for ${META_PROJECT_NAME}.")
        list(APPEND LIBRARIES_QT_RESOURCES ${PASSWORD_FILE_QT_RESOURCES})
    endif()
endmacro()
